package main;

import javax.swing.*;
import java.awt.*;
import java.io.Serial;

public class Window extends Canvas {
    private JFrame frame;




    @Serial
    private static final long serialVersionUID = -4810618286807932601L;

    public Window(int width, int height, String title, Game game) {
        frame  = new JFrame(title);

        frame.setPreferredSize(new Dimension(width, height));
        frame.setMaximumSize(new Dimension(width, height));
        frame.setMinimumSize(new Dimension(width, height));
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setResizable(false);
        frame.setLocationRelativeTo(null);
        frame.add(game);
        frame.setVisible(true);
        frame.setBackground(Color.BLACK);
        game.start();


    }
}
